Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.util
Class StringUtils

    java.lang.Object
      org.jivesoftware.util.StringUtils

    public class StringUtils

extends Object

Utility class to peform common String manipulation algorithms.

Method Summary
`static String` | `abbreviate(String str, int maxWidth)` Abbreviates a string to a specified length and then adds an ellipsis if the input is greater than the maxWidth.
`static String` | `chopAtWord(String string, int length)` Intelligently chops a String at a word boundary (whitespace) that occurs at the specified index in the argument or before.
`static String` | `collectionToString(Collection<String> collection)` Returns a collection of Strings as a comma-delimitted list of strings.
`static String` | `dateToMillis(Date date)` Formats a Date as a fifteen character long String made up of the Date's padded millisecond value.
`static byte[]` | `decodeBase64(String data)` Decodes a base64 String.
`static byte[]` | `decodeHex(String hex)` Turns a hex encoded string into a byte array.
`static String` | `encodeBase64(byte[] data)` Encodes a byte array into a base64 String.
`static String` | `encodeBase64(String data)` Encodes a String as a base64 String.
`static String` | `encodeHex(byte[] bytes)` Turns an array of bytes into a String representing each byte as an unsigned hex number.
`static String` | `escapeForSQL(String string)` Escapes all necessary characters in the String so that it can be used in SQL
`static String` | `escapeForXML(String string)` Escapes all necessary characters in the String so that it can be used in an XML doc.
`static String` | `escapeHTMLTags(String in)` This method takes a string which may contain HTML tags (ie, <b>, <table>, etc) and converts the '<'' and '>' characters to their HTML escape sequences.
`static String` | `escapeHTMLTags(String in, boolean includeLF)` This method takes a string which may contain HTML tags (ie, <b>, <table>, etc) and converts the '<'' and '>' characters to their HTML escape sequences.
`static byte[]` | `getBytes(String input)` Returns the UTF-8 bytes for the given String, suppressing UnsupportedEncodingException (in lieu of log message)
`static String` | `getElapsedTime(long delta)` Returns a textual representation for the time that has elapsed.
`static String` | `getString(byte[] input)` Returns the UTF-8 String for the given byte array, suppressing UnsupportedEncodingException (in lieu of log message)
`static String` | `getTimeFromLong(long diff)` Returns a formatted String from time.
`static String` | `hash(byte[] bytes, String algorithm)` Hashes a byte array using the specified algorithm and returns the result as a String of hexadecimal numbers.
`static String` | `hash(String data)` Hashes a String using the Md5 algorithm and returns the result as a String of hexadecimal numbers.
`static String` | `hash(String data, String algorithm)` Hashes a String using the specified algorithm and returns the result as a String of hexadecimal numbers.
`static boolean` | `isValidEmailAddress(String address)` Returns true if the string passed in is a valid Email address.
`static String` | `randomString(int length)` Returns a random String of numbers and letters (lower and upper case) of the specified length.
`static String` | `removeXSSCharacters(String input)` Removes characters likely to enable Cross Site Scripting attacks from the provided input string.
`static String` | `replace(String string, String oldString, String newString)` Replaces all instances of oldString with newString in string.
`static String` | `replace(String line, String oldString, String newString, int[] count)` Replaces all instances of oldString with newString in line.
`static String` | `replaceIgnoreCase(String line, String oldString, String newString)` Replaces all instances of oldString with newString in line with the added feature that matches of newString in oldString ignore case.
`static String` | `replaceIgnoreCase(String line, String oldString, String newString, int[] count)` Replaces all instances of oldString with newString in line with the added feature that matches of newString in oldString ignore case.
`static Collection<String>` | `stringToCollection(String string)` Returns a comma-delimitted list of Strings as a Collection.
`static String` | `stripTags(String in)` This method takes a string and strips out all tags except tags while still leaving the tag body intact.
`static String[]` | `toLowerCaseWordArray(String text)` Converts a line of text into an array of lower case words using a BreakIterator.wordInstance().
`static String` | `unescapeFromXML(String string)` Unescapes the String by converting XML escape sequences back into normal characters.
`static String` | `wordWrap(String input, int width, Locale locale)` Reformats a string where lines that are longer than `width` are split apart at the earliest wordbreak or at maxLength, whichever is sooner.
`static String` | `zeroPadString(String string, int length)` Pads the supplied String with 0's to the specified length and returns the result as a new String.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### replace

    public static String replace(String string,
                                 String oldString,
                                 String newString)

  Replaces all instances of oldString with newString in string.

  Parameters:
    `string` - the String to search to perform replacements on.
    `oldString` - the String that should be replaced by newString.
    `newString` - the String that will replace all instances of oldString.
  Returns:
    a String will all instances of oldString replaced by newString.

### replaceIgnoreCase

    public static String replaceIgnoreCase(String line,
                                           String oldString,
                                           String newString)

  Replaces all instances of oldString with newString in line with the added feature that matches of newString in oldString ignore case.

  Parameters:
    `line` - the String to search to perform replacements on
    `oldString` - the String that should be replaced by newString
    `newString` - the String that will replace all instances of oldString
  Returns:
    a String will all instances of oldString replaced by newString

### replaceIgnoreCase

    public static String replaceIgnoreCase(String line,
                                           String oldString,
                                           String newString,
                                           int[] count)

  Replaces all instances of oldString with newString in line with the added feature that matches of newString in oldString ignore case. The count paramater is set to the number of replaces performed.

  Parameters:
    `line` - the String to search to perform replacements on
    `oldString` - the String that should be replaced by newString
    `newString` - the String that will replace all instances of oldString
    `count` - a value that will be updated with the number of replaces performed.
  Returns:
    a String will all instances of oldString replaced by newString

### replace

    public static String replace(String line,
                                 String oldString,
                                 String newString,
                                 int[] count)

  Replaces all instances of oldString with newString in line. The count Integer is updated with number of replaces.

  Parameters:
    `line` - the String to search to perform replacements on.
    `oldString` - the String that should be replaced by newString.
    `newString` - the String that will replace all instances of oldString.
  Returns:
    a String will all instances of oldString replaced by newString.

### stripTags

    public static String stripTags(String in)

  This method takes a string and strips out all tags except
  tags while still leaving the tag body intact.

  Parameters:
    `in` - the text to be converted.
  Returns:
    the input string with all tags removed.

### escapeHTMLTags

    public static String escapeHTMLTags(String in)

  This method takes a string which may contain HTML tags (ie, <b>, <table>, etc) and converts the '<'' and '>' characters to their HTML escape sequences. It will also replace LF with <br>.

  Parameters:
    `in` - the text to be converted.
  Returns:
    the input string with the characters '<' and '>' replaced with their HTML escape sequences.

### escapeHTMLTags

    public static String escapeHTMLTags(String in,
                                        boolean includeLF)

  This method takes a string which may contain HTML tags (ie, <b>, <table>, etc) and converts the '<'' and '>' characters to their HTML escape sequences.

  Parameters:
    `in` - the text to be converted.
    `includeLF` - set to true to replace \n with
    .
  Returns:
    the input string with the characters '<' and '>' replaced with their HTML escape sequences.

### hash

    public static String hash(String data)

  Hashes a String using the Md5 algorithm and returns the result as a String of hexadecimal numbers. This method is synchronized to avoid excessive MessageDigest object creation. If calling this method becomes a bottleneck in your code, you may wish to maintain a pool of MessageDigest objects instead of using this method.

  A hash is a one-way function -- that is, given an input, an output is easily computed. However, given the output, the input is almost impossible to compute. This is useful for passwords since we can store the hash and a hacker will then have a very hard time determining the original password.

  In Jive, every time a user logs in, we simply take their plain text password, compute the hash, and compare the generated hash to the stored hash. Since it is almost impossible that two passwords will generate the same hash, we know if the user gave us the correct password or not. The only negative to this system is that password recovery is basically impossible. Therefore, a reset password method is used instead.

  Parameters:
    `data` - the String to compute the hash of.
  Returns:
    a hashed version of the passed-in String

### hash

    public static String hash(String data,
                              String algorithm)

  Hashes a String using the specified algorithm and returns the result as a String of hexadecimal numbers. This method is synchronized to avoid excessive MessageDigest object creation. If calling this method becomes a bottleneck in your code, you may wish to maintain a pool of MessageDigest objects instead of using this method.

  A hash is a one-way function -- that is, given an input, an output is easily computed. However, given the output, the input is almost impossible to compute. This is useful for passwords since we can store the hash and a hacker will then have a very hard time determining the original password.

  In Jive, every time a user logs in, we simply take their plain text password, compute the hash, and compare the generated hash to the stored hash. Since it is almost impossible that two passwords will generate the same hash, we know if the user gave us the correct password or not. The only negative to this system is that password recovery is basically impossible. Therefore, a reset password method is used instead.

  Parameters:
    `data` - the String to compute the hash of.
    `algorithm` - the name of the algorithm requested.
  Returns:
    a hashed version of the passed-in String

### hash

    public static String hash(byte[] bytes,
                              String algorithm)

  Hashes a byte array using the specified algorithm and returns the result as a String of hexadecimal numbers. This method is synchronized to avoid excessive MessageDigest object creation. If calling this method becomes a bottleneck in your code, you may wish to maintain a pool of MessageDigest objects instead of using this method.

  A hash is a one-way function -- that is, given an input, an output is easily computed. However, given the output, the input is almost impossible to compute. This is useful for passwords since we can store the hash and a hacker will then have a very hard time determining the original password.

  In Jive, every time a user logs in, we simply take their plain text password, compute the hash, and compare the generated hash to the stored hash. Since it is almost impossible that two passwords will generate the same hash, we know if the user gave us the correct password or not. The only negative to this system is that password recovery is basically impossible. Therefore, a reset password method is used instead.

  Parameters:
    `bytes` - the byte array to compute the hash of.
    `algorithm` - the name of the algorithm requested.
  Returns:
    a hashed version of the passed-in String

### encodeHex

    public static String encodeHex(byte[] bytes)

  Turns an array of bytes into a String representing each byte as an unsigned hex number.

  Method by Santeri Paavolainen, Helsinki Finland 1996
  (c) Santeri Paavolainen, Helsinki Finland 1996
  Distributed under LGPL.

  Parameters:
    `bytes` - an array of bytes to convert to a hex-string
  Returns:
    generated hex string

### decodeHex

    public static byte[] decodeHex(String hex)

  Turns a hex encoded string into a byte array. It is specifically meant to "reverse" the toHex(byte[]) method.

  Parameters:
    `hex` - a hex encoded String to transform into a byte array.
  Returns:
    a byte array representing the hex String[

### encodeBase64

    public static String encodeBase64(String data)

  Encodes a String as a base64 String.

  Parameters:
    `data` - a String to encode.
  Returns:
    a base64 encoded String.

### encodeBase64

    public static String encodeBase64(byte[] data)

  Encodes a byte array into a base64 String.

  Parameters:
    `data` - a byte array to encode.
  Returns:
    a base64 encode String.

### decodeBase64

    public static byte[] decodeBase64(String data)

  Decodes a base64 String.

  Parameters:
    `data` - a base64 encoded String to decode.
  Returns:
    the decoded String.

### toLowerCaseWordArray

    public static String[] toLowerCaseWordArray(String text)

  Converts a line of text into an array of lower case words using a BreakIterator.wordInstance().

  This method is under the Jive Open Source Software License and was written by Mark Imbriaco.

  Parameters:
    `text` - a String of text to convert into an array of words
  Returns:
    text broken up into an array of words.

### randomString

    public static String randomString(int length)

  Returns a random String of numbers and letters (lower and upper case) of the specified length. The method uses the Random class that is built-in to Java which is suitable for low to medium grade security uses. This means that the output is only pseudo random, i.e., each number is mathematically generated so is not truly random.

  The specified length must be at least one. If not, the method will return null.

  Parameters:
    `length` - the desired length of the random String to return.
  Returns:
    a random String of numbers and letters of the specified length.

### chopAtWord

    public static String chopAtWord(String string,
                                    int length)

  Intelligently chops a String at a word boundary (whitespace) that occurs at the specified index in the argument or before. However, if there is a newline character before `length`, the String will be chopped there. If no newline or whitespace is found in `string` up to the index `length`, the String will chopped at `length`.

  For example, chopAtWord("This is a nice String", 10) will return "This is a" which is the first word boundary less than or equal to 10 characters into the original String.

  Parameters:
    `string` - the String to chop.
    `length` - the index in `string` to start looking for a whitespace boundary at.
  Returns:
    a substring of `string` whose length is less than or equal to `length`, and that is chopped at whitespace.

### wordWrap

    public static String wordWrap(String input,
                                  int width,
                                  Locale locale)

  Reformats a string where lines that are longer than `width` are split apart at the earliest wordbreak or at maxLength, whichever is sooner. If the width specified is less than 5 or greater than the input Strings length the string will be returned as is.

  Please note that this method can be lossy - trailing spaces on wrapped lines may be trimmed.

  Parameters:
    `input` - the String to reformat.
    `width` - the maximum length of any one line.
  Returns:
    a new String with reformatted as needed.

### escapeForSQL

    public static String escapeForSQL(String string)

  Escapes all necessary characters in the String so that it can be used in SQL

  Parameters:
    `string` - the string to escape.
  Returns:
    the string with appropriate characters escaped.

### escapeForXML

    public static String escapeForXML(String string)

  Escapes all necessary characters in the String so that it can be used in an XML doc.

  Parameters:
    `string` - the string to escape.
  Returns:
    the string with appropriate characters escaped.

### unescapeFromXML

    public static String unescapeFromXML(String string)

  Unescapes the String by converting XML escape sequences back into normal characters.

  Parameters:
    `string` - the string to unescape.
  Returns:
    the string with appropriate characters unescaped.

### zeroPadString

    public static String zeroPadString(String string,
                                       int length)

  Pads the supplied String with 0's to the specified length and returns the result as a new String. For example, if the initial String is "9999" and the desired length is 8, the result would be "00009999". This type of padding is useful for creating numerical values that need to be stored and sorted as character data. Note: the current implementation of this method allows for a maximum `length` of 64.

  Parameters:
    `string` - the original String to pad.
    `length` - the desired length of the new padded String.
  Returns:
    a new String padded with the required number of 0's.

### dateToMillis

    public static String dateToMillis(Date date)

  Formats a Date as a fifteen character long String made up of the Date's padded millisecond value.

  Returns:
    a Date encoded as a String.

### getElapsedTime

    public static String getElapsedTime(long delta)

  Returns a textual representation for the time that has elapsed.

  Parameters:
    `delta` - the elapsed time.
  Returns:
    textual representation for the time that has elapsed.

### getTimeFromLong

    public static String getTimeFromLong(long diff)

  Returns a formatted String from time.

  Parameters:
    `diff` - the amount of elapsed time.
  Returns:
    the formatte String.

### collectionToString

    public static String collectionToString(Collection<String> collection)

  Returns a collection of Strings as a comma-delimitted list of strings.

  Returns:
    a String representing the Collection.

### stringToCollection

    public static Collection<String> stringToCollection(String string)

  Returns a comma-delimitted list of Strings as a Collection.

  Returns:
    a Collection representing the String.

### abbreviate

    public static String abbreviate(String str,
                                    int maxWidth)

  Abbreviates a string to a specified length and then adds an ellipsis if the input is greater than the maxWidth. Example input:

            user1@jivesoftware.com/home

  and a maximum length of 20 characters, the abbreviate method will return:

            user1@jivesoftware.c...

  Parameters:
    `str` - the String to abbreviate.
    `maxWidth` - the maximum size of the string, minus the ellipsis.
  Returns:
    the abbreviated String, or `null` if the string was `null`.

### isValidEmailAddress

    public static boolean isValidEmailAddress(String address)

  Returns true if the string passed in is a valid Email address.

  Parameters:
    `address` - Email address to test for validity.
  Returns:
    true if the string passed in is a valid email address.

### removeXSSCharacters

    public static String removeXSSCharacters(String input)

  Removes characters likely to enable Cross Site Scripting attacks from the provided input string. The characters that are removed from the input string, if present, are:

       < > " ' % ; ) ( & + -

  Parameters:
    `input` - the string to be scrubbed
  Returns:
    Input without certain characters;

### getBytes

    public static byte[] getBytes(String input)

  Returns the UTF-8 bytes for the given String, suppressing UnsupportedEncodingException (in lieu of log message)

  Parameters:
    `input` - The source string
  Returns:
    The UTF-8 encoding for the given string

### getString

    public static String getString(byte[] input)

  Returns the UTF-8 String for the given byte array, suppressing UnsupportedEncodingException (in lieu of log message)

  Parameters:
    `input` - The source byte array
  Returns:
    The UTF-8 encoded String for the given byte array

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.